#!/usr/bin/python

from PyQt4 import QtCore
from PyQt4.QtGui import *

import sys

sys.path.append(r'/usr/share/pyconverter')
import converter

class QtConverter(QWidget):

	def __init__(self, parent=None):
		QWidget.__init__(self, parent)
		self.setWindowTitle('QT Converter v0.1')
		grid = QGridLayout()

		self.changing = False
		self.converter = converter.Converter(r'/usr/share/pyconverter')

		self.types = QComboBox()
		self.types.addItems(self.converter.getTypeList())
		self.connect(self.types, QtCore.SIGNAL('currentIndexChanged(int)'), self.loadFromToPick)

		grid.addWidget(QLabel('Conversion Type:'), 0, 0)
		grid.addWidget(self.types, 0, 1)

		self.conv_f = QComboBox()
		self.connect(self.conv_f, QtCore.SIGNAL('currentIndexChanged(int)'), self.updateResults)

		self.conv_t = QComboBox()
		self.connect(self.conv_t, QtCore.SIGNAL('currentIndexChanged(int)'), self.updateResults)

		self.data_f = QLineEdit()
		self.data_f.setValidator(QDoubleValidator(self.data_f))

		self.data_t = QLabel('?')

		btn_ok = QPushButton('Convert')
		self.connect(btn_ok, QtCore.SIGNAL('clicked()'), self.doConversion)

		grid.addWidget(QLabel('From:'), 1, 0)
		grid.addWidget(self.conv_f, 2, 0)
		grid.addWidget(self.data_f, 2, 1)

		grid.addWidget(QLabel('To:'), 3, 0)
		grid.addWidget(self.conv_t, 4, 0)
		grid.addWidget(self.data_t, 4, 1)

		grid.addWidget(btn_ok, 5, 0, 5, -1)

		self.setLayout(grid)
		self.types.setCurrentIndex(0)
		self.loadFromToPick(0)

	def doConversion(self):
		if self.changing:
			return
		old = str(self.conv_f.currentText())
		new = str(self.conv_t.currentText())
		val = str(self.data_f.text())
		self.data_t.setText(self.converter.doConversion(old, new, val))

	def updateResults(self, index):
		self.doConversion()

	def loadFromToPick(self, index):
		# keep the changing pickers from triggering their signals
		self.changing = True

		# get the choices
		self.converter.setType(index)
		pick = self.converter.getUnitList()

		# update the 'from' picker
		self.conv_f.clear()
		self.conv_f.addItems(pick)
		self.conv_f.setCurrentIndex(0)

		# update the 'to' picker
		self.conv_t.clear()
		self.conv_t.addItems(pick)
		self.conv_t.setCurrentIndex(1)

		# okay, back to normal
		self.changing = False

# run the program
if __name__ == '__main__':
	app = QApplication(sys.argv)
	win = QtConverter()
	win.show()
	sys.exit(app.exec_())
